diff --git a/hw/xquartz/X11Application.m b/hw/xquartz/X11Application.m
index 752ddc3f6..0b1335553 100644
--- a/hw/xquartz/X11Application.m
+++ b/hw/xquartz/X11Application.m
@@ -756,64 +1249,91 @@ - (void) copy:sender
 void
 X11ApplicationMain(int argc, char **argv, char **envp)
 {
+    NSAutoreleasePool *pool;
+
 #ifdef DEBUG
     while (access("/tmp/x11-block", F_OK) == 0) sleep(1);
 #endif
 
-    @autoreleasepool {
-        X11App = (X11Application *)[X11Application sharedApplication];
-        [X11App read_defaults];
+    pool = [[NSAutoreleasePool alloc] init];
+    X11App = (X11Application *)[X11Application sharedApplication];
+    init_ports();
 
-        [NSBundle loadNibNamed:@"main" owner:NSApp];
-        [NSNotificationCenter.defaultCenter addObserver:NSApp
-                                               selector:@selector (became_key:)
-                                                   name:NSWindowDidBecomeKeyNotification
-                                                 object:nil];
+    app_prefs_domain_cfstr =
+        (CFStringRef)[[NSBundle mainBundle] bundleIdentifier];
 
-        /*
-         * The xpr Quartz mode is statically linked into this server.
-         * Initialize all the Quartz functions.
-         */
-        QuartzModeBundleInit();
+    if (app_prefs_domain_cfstr == NULL) {
+        ErrorF(
+            "X11ApplicationMain: Unable to determine bundle identifier.  Your installation of XQuartz may be broken.\n");
+        app_prefs_domain_cfstr = CFSTR(BUNDLE_ID_PREFIX ".X11");
+    }
 
-        /* Calculate the height of the menubar so we can avoid it. */
-        aquaMenuBarHeight = NSApp.mainMenu.menuBarHeight;
-        if (!aquaMenuBarHeight) {
-            NSScreen* primaryScreen = NSScreen.screens[0];
-            aquaMenuBarHeight = NSHeight(primaryScreen.frame) - NSMaxY(primaryScreen.visibleFrame);
-        }
+    [NSApp read_defaults];
+    [NSBundle loadNibNamed:@"main" owner:NSApp];
+    [[NSNotificationCenter defaultCenter] addObserver:NSApp
+                                             selector:@selector (became_key:)
+                                                 name:
+     NSWindowDidBecomeKeyNotification object:nil];
 
-        eventTranslationQueue = dispatch_queue_create(BUNDLE_ID_PREFIX ".X11.NSEventsToX11EventsQueue", NULL);
-        assert(eventTranslationQueue != NULL);
+    /*
+     * The xpr Quartz mode is statically linked into this server.
+     * Initialize all the Quartz functions.
+     */
+    QuartzModeBundleInit();
 
-        /* Set the key layout seed before we start the server */
-        last_key_layout = TISCopyCurrentKeyboardLayoutInputSource();
+    /* Calculate the height of the menubar so we can avoid it. */
+    aquaMenuBarHeight = [[NSApp mainMenu] menuBarHeight];
+#if ! __LP64__
+    if (!aquaMenuBarHeight) {
+        aquaMenuBarHeight = [NSMenuView menuBarHeight];
+    }
+#endif
+    if (!aquaMenuBarHeight) {
+        NSScreen* primaryScreen = [[NSScreen screens] objectAtIndex:0];
+        aquaMenuBarHeight = NSHeight([primaryScreen frame]) - NSMaxY([primaryScreen visibleFrame]);
+    }
 
-        if (!last_key_layout) {
-            ErrorF("X11ApplicationMain: Unable to determine TISCopyCurrentKeyboardLayoutInputSource() at startup.\n");
-        }
+#ifdef HAVE_LIBDISPATCH
+    eventTranslationQueue = dispatch_queue_create(
+        BUNDLE_ID_PREFIX ".X11.NSEventsToX11EventsQueue", NULL);
+    assert(eventTranslationQueue != NULL);
+#endif
 
-        if (!QuartsResyncKeymap(FALSE)) {
-            ErrorF("X11ApplicationMain: Could not build a valid keymap.\n");
-        }
+    /* Set the key layout seed before we start the server */
+#if MAC_OS_X_VERSION_MIN_REQUIRED >= 1050
+    last_key_layout = TISCopyCurrentKeyboardLayoutInputSource();
+
+    if (!last_key_layout)
+        ErrorF(
+            "X11ApplicationMain: Unable to determine TISCopyCurrentKeyboardLayoutInputSource() at startup.\n");
+#else
+    KLGetCurrentKeyboardLayout(&last_key_layout);
+    if (!last_key_layout)
+        ErrorF(
+            "X11ApplicationMain: Unable to determine KLGetCurrentKeyboardLayout() at startup.\n");
+#endif
+
+    if (!QuartsResyncKeymap(FALSE)) {
+        ErrorF("X11ApplicationMain: Could not build a valid keymap.\n");
+    }
 
-        /* Tell the server thread that it can proceed */
-        QuartzInitServer(argc, argv, envp);
+    /* Tell the server thread that it can proceed */
+    QuartzInitServer(argc, argv, envp);
 
-        /* This must be done after QuartzInitServer because it can result in
-         * an mieqEnqueue() - <rdar://problem/6300249>
-         */
-        check_xinitrc();
+    /* This must be done after QuartzInitServer because it can result in
+     * an mieqEnqueue() - <rdar://problem/6300249>
+     */
+    check_xinitrc();
 
-        create_thread(xpbproxy_x_thread, NULL);
+    create_thread(xpbproxy_x_thread, NULL);
 
 #if XQUARTZ_SPARKLE
-        [[X11App controller] setup_sparkle];
-        [[SUUpdater sharedUpdater] resetUpdateCycle];
-        //    [[SUUpdater sharedUpdater] checkForUpdates:X11App];
+    [[X11App controller] setup_sparkle];
+    [[SUUpdater sharedUpdater] resetUpdateCycle];
+    //    [[SUUpdater sharedUpdater] checkForUpdates:X11App];
 #endif
-    }
 
+    [pool release];
     [NSApp run];
     /* not reached */
 }
@@ -1017,16 +1537,7 @@ - (void) sendX11NSEvent:(NSEvent *)e
         goto handle_mouse;
 
     case NSOtherMouseDown:
-        // Get the AppKit button number, and convert it from 0-based to 1-based
-        ev_button = [e buttonNumber] + 1;
-
-        /* Translate middle mouse button (3 in AppKit) to button 2 in X11,
-         * and translate additional mouse buttons (4 and higher in AppKit)
-         * to buttons 8 and higher in X11, to match default behavior of X11
-         * on other platforms
-         */
-        ev_button = (ev_button == 3) ? 2 : (ev_button + 4);
-
+        ev_button = 2;
         ev_type = ButtonPress;
         goto handle_mouse;
 
@@ -1041,9 +1552,7 @@ - (void) sendX11NSEvent:(NSEvent *)e
         goto handle_mouse;
 
     case NSOtherMouseUp:
-        // See above comments for NSOtherMouseDown
-        ev_button = [e buttonNumber] + 1;
-        ev_button = (ev_button == 3) ? 2 : (ev_button + 4);
+        ev_button = 2;
         ev_type = ButtonRelease;
         goto handle_mouse;
 
@@ -1058,9 +1567,7 @@ - (void) sendX11NSEvent:(NSEvent *)e
         goto handle_mouse;
 
     case NSOtherMouseDragged:
-        // See above comments for NSOtherMouseDown
-        ev_button = [e buttonNumber] + 1;
-        ev_button = (ev_button == 3) ? 2 : (ev_button + 4);
+        ev_button = 2;
         ev_type = MotionNotify;
         goto handle_mouse;
 
@@ -1127,6 +1634,8 @@ - (void) sendX11NSEvent:(NSEvent *)e
         }
 
         if (!XQuartzServerVisible && noTestExtensions) {
+#if defined(XPLUGIN_VERSION) && XPLUGIN_VERSION > 0
+            /* Older libXplugin (Tiger/"Stock" Leopard) aren't thread safe, so we can't call xp_find_window from the Appkit thread */
             xp_window_id wid = 0;
             xp_error err;
 
@@ -1139,6 +1648,7 @@ - (void) sendX11NSEvent:(NSEvent *)e
             err = xp_find_window(location.x, location.y, 0, &wid);
 
             if (err != XP_Success || (err == XP_Success && wid == 0))
+#endif
             {
                 bgMouseLocation = location;
                 bgMouseLocationUpdated = TRUE;
@@ -1194,6 +1704,11 @@ - (void) sendX11NSEvent:(NSEvent *)e
 
     case NSScrollWheel:
     {
+#if MAC_OS_X_VERSION_MAX_ALLOWED < 1050
+        float deltaX = [e deltaX];
+        float deltaY = [e deltaY];
+        BOOL isContinuous = NO;
+#else
         CGFloat deltaX = [e deltaX];
         CGFloat deltaY = [e deltaY];
         CGEventRef cge = [e CGEvent];
@@ -1215,12 +1730,28 @@ - (void) sendX11NSEvent:(NSEvent *)e
             deltaY *= lineHeight / 5.0;
         }
 #endif
+#endif
         
-        if (XQuartzScrollInDeviceDirection &&
+#if !defined(XPLUGIN_VERSION) || XPLUGIN_VERSION == 0
+        /* If we're in the background, we need to send a MotionNotify event
+         * first, since we aren't getting them on background mouse motion
+         */
+        if (!XQuartzServerVisible && noTestExtensions) {
+            bgMouseLocationUpdated = FALSE;
+            DarwinSendPointerEvents(darwinPointer, MotionNotify, 0,
+                                    location.x, location.y,
+                                    0.0, 0.0);
+        }
+#endif
+#if MAC_OS_X_VERSION_MAX_ALLOWED >= 1070
+        // TODO: Change 1117 to NSAppKitVersionNumber10_7 when it is defined
+        if (NSAppKitVersionNumber >= 1117 &&
+            XQuartzScrollInDeviceDirection &&
             [e isDirectionInvertedFromDevice]) {
             deltaX *= -1;
             deltaY *= -1;
         }
+#endif
         /* This hack is in place to better deal with "clicky" scroll wheels:
          * http://xquartz.macosforge.org/trac/ticket/562
          */
@@ -1326,17 +1857,9 @@ - (void) sendX11NSEvent:(NSEvent *)e
     }
 
         if (darwinSyncKeymap) {
-            __block TISInputSourceRef key_layout;
-            dispatch_block_t copyCurrentKeyboardLayoutInputSource = ^{
-                key_layout = TISCopyCurrentKeyboardLayoutInputSource();
-            };
-            /* This is an ugly ant-pattern, but it is more expedient to address the problem right now. */
-            if (pthread_main_np()) {
-                copyCurrentKeyboardLayoutInputSource();
-            } else {
-                dispatch_sync(dispatch_get_main_queue(), copyCurrentKeyboardLayoutInputSource);
-            }
-
+#if MAC_OS_X_VERSION_MIN_REQUIRED >= 1050
+            TISInputSourceRef key_layout = 
+                TISCopyCurrentKeyboardLayoutInputSource();
             TISInputSourceRef clear;
             if (CFEqual(key_layout, last_key_layout)) {
                 CFRelease(key_layout);
@@ -1346,7 +1869,12 @@ - (void) sendX11NSEvent:(NSEvent *)e
                 clear = last_key_layout;
                 last_key_layout = key_layout;
                 CFRelease(clear);
-
+#else
+            KeyboardLayoutRef key_layout;
+            KLGetCurrentKeyboardLayout(&key_layout);
+            if (key_layout != last_key_layout) {
+                last_key_layout = key_layout;
+#endif
                 /* Update keyInfo */
                 if (!QuartsResyncKeymap(TRUE)) {
                     ErrorF(
diff --git a/hw/xquartz/X11Controller.h b/hw/xquartz/X11Controller.h
index d5be0e8b6..c8b501831 100644
--- a/hw/xquartz/X11Controller.h
+++ b/hw/xquartz/X11Controller.h
@@ -46,43 +46,76 @@
 #undef BOOL
 #endif
 
-@interface X11Controller : NSObject <NSTableViewDataSource>
-@property (nonatomic, readwrite, strong) IBOutlet NSPanel *prefs_panel;
-
-@property (nonatomic, readwrite, strong) IBOutlet NSButton *fake_buttons;
-@property (nonatomic, readwrite, strong) IBOutlet NSButton *enable_fullscreen;
-@property (nonatomic, readwrite, strong) IBOutlet NSButton *enable_fullscreen_menu;
-@property (nonatomic, readwrite, strong) IBOutlet NSTextField *enable_fullscreen_menu_text;
-@property (nonatomic, readwrite, strong) IBOutlet NSButton *enable_keyequivs;
-@property (nonatomic, readwrite, strong) IBOutlet NSButton *sync_keymap;
-@property (nonatomic, readwrite, strong) IBOutlet NSButton *option_sends_alt;
-@property (nonatomic, readwrite, strong) IBOutlet NSButton *scroll_in_device_direction;
-@property (nonatomic, readwrite, strong) IBOutlet NSButton *click_through;
-@property (nonatomic, readwrite, strong) IBOutlet NSButton *focus_follows_mouse;
-@property (nonatomic, readwrite, strong) IBOutlet NSButton *focus_on_new_window;
-@property (nonatomic, readwrite, strong) IBOutlet NSButton *enable_auth;
-@property (nonatomic, readwrite, strong) IBOutlet NSButton *enable_tcp;
-@property (nonatomic, readwrite, strong) IBOutlet NSButton *sync_pasteboard;
-@property (nonatomic, readwrite, strong) IBOutlet NSButton *sync_pasteboard_to_clipboard;
-@property (nonatomic, readwrite, strong) IBOutlet NSButton *sync_pasteboard_to_primary;
-@property (nonatomic, readwrite, strong) IBOutlet NSButton *sync_clipboard_to_pasteboard;
-@property (nonatomic, readwrite, strong) IBOutlet NSButton *sync_primary_immediately;
-@property (nonatomic, readwrite, strong) IBOutlet NSTextField *sync_text1;
-@property (nonatomic, readwrite, strong) IBOutlet NSTextField *sync_text2;
-@property (nonatomic, readwrite, strong) IBOutlet NSPopUpButton *depth;
-
-@property (nonatomic, readwrite, strong) IBOutlet NSMenuItem *x11_about_item;
-@property (nonatomic, readwrite, strong) IBOutlet NSMenuItem *dock_window_separator;
-@property (nonatomic, readwrite, strong) IBOutlet NSMenuItem *apps_separator;
-@property (nonatomic, readwrite, strong) IBOutlet NSMenuItem *toggle_fullscreen_item;
-
-@property (nonatomic, readwrite, strong) IBOutlet NSMenuItem *copy_menu_item;
-@property (nonatomic, readwrite, strong) IBOutlet NSMenu *dock_apps_menu;
-@property (nonatomic, readwrite, strong) IBOutlet NSTableView *apps_table;
-
-@property (nonatomic, readwrite, strong) IBOutlet NSMenu *dock_menu;
-
-@property (nonatomic, readwrite, assign) OSX_BOOL can_quit;
+#ifndef NSINTEGER_DEFINED
+#if __LP64__ || NS_BUILD_32_LIKE_64
+typedef long NSInteger;
+typedef unsigned long NSUInteger;
+#else
+typedef int NSInteger;
+typedef unsigned int NSUInteger;
+#endif
+#endif
+
+@interface X11Controller : NSObject
+#if MAC_OS_X_VERSION_MIN_REQUIRED >= 1060
+    <NSTableViewDataSource>
+#endif
+{
+    IBOutlet NSPanel *prefs_panel;
+
+    IBOutlet NSButton *fake_buttons;
+    IBOutlet NSButton *enable_fullscreen;
+    IBOutlet NSButton *enable_fullscreen_menu;
+    IBOutlet NSTextField *enable_fullscreen_menu_text;
+    IBOutlet NSButton *enable_keyequivs;
+    IBOutlet NSButton *sync_keymap;
+    IBOutlet NSButton *option_sends_alt;
+    IBOutlet NSButton *scroll_in_device_direction;
+    IBOutlet NSButton *click_through;
+    IBOutlet NSButton *focus_follows_mouse;
+    IBOutlet NSButton *focus_on_new_window;
+    IBOutlet NSButton *enable_auth;
+    IBOutlet NSButton *enable_tcp;
+    IBOutlet NSButton *sync_pasteboard;
+    IBOutlet NSButton *sync_pasteboard_to_clipboard;
+    IBOutlet NSButton *sync_pasteboard_to_primary;
+    IBOutlet NSButton *sync_clipboard_to_pasteboard;
+    IBOutlet NSButton *sync_primary_immediately;
+    IBOutlet NSTextField *sync_text1;
+    IBOutlet NSTextField *sync_text2;
+    IBOutlet NSPopUpButton *depth;
+
+    IBOutlet NSMenuItem *window_separator;
+    // window_separator is DEPRECATED due to this radar:
+    // <rdar://problem/7088335> NSApplication releases the separator in the Windows menu even though it's an IBOutlet
+    // It is kept around for localization compatibility and is subject to removal "eventually"
+    // If it is !NULL (meaning it is in the nib), it is removed from the menu and released
+
+    IBOutlet NSMenuItem *x11_about_item;
+    IBOutlet NSMenuItem *dock_window_separator;
+    IBOutlet NSMenuItem *apps_separator;
+    IBOutlet NSMenuItem *toggle_fullscreen_item;
+#ifdef XQUARTZ_SPARKLE
+    NSMenuItem *check_for_updates_item; // Programmatically enabled
+#endif
+    IBOutlet NSMenuItem *copy_menu_item;
+    IBOutlet NSMenu *dock_apps_menu;
+    IBOutlet NSTableView *apps_table;
+
+    NSArray *apps;
+    NSMutableArray *table_apps;
+
+    IBOutlet NSMenu *dock_menu;
+
+    // This is where in the Windows menu we'll start (this will be the index of the separator)
+    NSInteger windows_menu_start;
+
+    int checked_window_item;
+    x_list *pending_apps;
+
+    OSX_BOOL finished_launching;
+    OSX_BOOL can_quit;
+}
 
 - (void)set_window_menu:(NSArray *)list;
 - (void)set_window_menu_check:(NSNumber *)n;
@@ -92,6 +125,7 @@
 - (void)updater:(SUUpdater *)updater willInstallUpdate:(SUAppcastItem *)
    update;
 #endif
+- (void)set_can_quit:(OSX_BOOL)state;
 - (void)server_ready;
 - (OSX_BOOL)application:(NSApplication *)app openFile:(NSString *)filename;
 
